// FILE: SortFrame.java


import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;

/**
   A frame for showing a graphical editor
*/
public class StockFrame extends JInternalFrame
{
   static final int xOffset = 30, yOffset = 30;
   static int openFrameCount = 0;
   /**
     Constructs a sort frame with a sorting object

    */
      public StockFrame(int s)
      {
         super("Document #" + (++openFrameCount) + ": " +
              "Depth/Breadth First Search",
            true, //resizable
            true, //closable
            true, //maximizable
            true);//iconifiable

         //Set the window's location.
         setLocation(xOffset*(openFrameCount-1),
                  yOffset*(openFrameCount-1));

		 if(s == 90)
         	setTitle("Bull Financial Market");
         else
         	setTitle("Bear Financial Market");

		 stPanel2 = new StockPanel2();
         stPanel = new StockPanel(s, stPanel2);
		 stPanel.reset();

         JPanel group = new JPanel();
  		 JButton bReset = new JButton("Reset");
         bReset.addActionListener( new
          ActionListener()
          {
             public void actionPerformed(ActionEvent e)
             {
                  stPanel.reset();
                  stPanel2.reset();
             }
          });
		 JButton bRandom = new JButton("Random");
         bRandom.addActionListener( new
          ActionListener()
          {
             public void actionPerformed(ActionEvent e)
             {
                  stPanel.random();
             }
          });
         JButton start = new JButton("Start");
         start.addActionListener( new
          ActionListener()
          {
             public void actionPerformed(ActionEvent e)
             {
                  stPanel.start();
             }
          });
         JButton stop = new JButton("Stop");
         stop.addActionListener( new
           ActionListener()
           {
             public void actionPerformed(ActionEvent e)
             {
                  stPanel.stop();
             }
           });
      	 final JSlider zoom = new JSlider(JSlider.HORIZONTAL, 2, 14, 2);
      	 ChangeListener listener = new ChangeListener()
		 {
			public void stateChanged(ChangeEvent event)
			{
				stPanel.zoom(zoom.getValue());
			}
		  };
      	 final JSlider speed = new JSlider(JSlider.HORIZONTAL, 1, 10, 1);
      	 ChangeListener listener2 = new ChangeListener()
		 {
			public void stateChanged(ChangeEvent event)
			{
				stPanel.speed(speed.getValue());
			}
		  };
		 zoom.addChangeListener(listener);
		 speed.addChangeListener(listener2);
		 JPanel group2 = new JPanel();
		 zoom.setSize(10 ,2);
		 speed.setSize(10, 2);
		 zoom.setPaintTicks(true);
		 speed.setPaintTicks(true);
         group2.add(zoom);
         group2.add(speed);
         group.add(start);
         group.add(stop);
         group.add(bRandom);
         group.add(bReset);
		 this.validate();

         // trying to add a split pane
      	 JSplitPane splitPane = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT, stPanel, stPanel2);
     	 splitPane.setOneTouchExpandable(true);
     	 splitPane.setDividerLocation(300);

     	 Container contentPane = getContentPane();

     	 contentPane.add(splitPane, BorderLayout.CENTER);
     	 contentPane.add(group, BorderLayout.SOUTH);
     	 contentPane.add(group2, BorderLayout.NORTH);
     	 group2.validate();
		 this.validate();
     	 setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
     	 addInternalFrameListener(new
         InternalFrameAdapter()
         {
            public void internalFrameClosing(InternalFrameEvent e)
            {
               exit();
            }
         });
   }

   /**
      Confirms that the user wants to exit and exits
      upon confirmation.
   */
   private void exit()
   {
         dispose();
   }// End exit()
   public void stop()
   {
	   stPanel.stop();
   }
   private StockPanel stPanel;
   private StockPanel2 stPanel2;
}// End GraphFrame