

import java.awt.*;
import java.awt.event.*;
import java.awt.geom.*;
import javax.swing.*;
import java.util.*;
import java.lang.Integer;

import javax.swing.*;
import java.awt.*;
import java.util.Calendar;
import java.awt.event.*;
import javax.swing.event.*;

public class StockPanel extends JPanel implements Runnable
{

    public StockPanel(int s, StockPanel2 sp)
    {
		this.sp = sp;
		String theBinary2 = Integer.toBinaryString(s);

		for(int i = theBinary2.length(); i < 8; i++)
		{
			theBinary += "0";
		}
		theBinary += theBinary2;
		for (int i = 0; i < WIDTH; i++)
		{
			for (int j = 0; j < HEIGHT; j++)
			{
				cells[i][j] = 0;
			}
		}
		cells[WIDTH/2 - 1][HEIGHT - 1] = 1;
    }
	public void setS(int s)
	{
		String theBinary2 = Integer.toBinaryString(s);

		for(int i = theBinary2.length(); i < 8; i++)
		{
			theBinary += "0";
		}
		theBinary += theBinary2;
	}
    public void paintComponent(Graphics g)
    {
        super.paintComponent(g);
		update(g);
    }
    public void draw(Graphics g)
    {
		if(zoom == 1)
		{
			for(int i = 0; i < WIDTH;i++)
			{
				for(int j = 0; j < HEIGHT; j++)
				{
					if(cells[i][j] == 0)
					{
						g.setColor(white);
						g.fillRect(i, j, 1, 1);
					}
					else
					{
						g.setColor(black);
						g.fillRect(i, j, 1, 1);
					}
				}
			}
		}
		else
		{
			int x = zoom;
			int z3 = PWIDTH/x;
			int z4 = PHEIGHT/x;
			int z6 = WIDTH/2 - z3/2 - 1;
			int z9 = HEIGHT - z4 - 1;
			for(int i = 0; i < z3 + 1;i++)
			{
				for(int j = 0; j < z4 + 1; j++)
				{
					if(cells[i + z6][j + z9] == 0)
					{
						g.setColor(white);
						g.fillRect(i * x, j * x, x, x);
					}
					else
					{
						g.setColor(black);
						g.fillRect(i * x, j * x, x, x);
					}
				}
			}
		}
	}
    public void update(Graphics g)
    {
        Dimension d = getSize();
        if(offGraphics == null || offDimension.width != d.width)
        {
			offDimension = d;
			offImage = createImage(d.width, d.height);
			offGraphics = offImage.getGraphics();
		}
		draw(offGraphics);

		g.drawImage(offImage, 0, 0, this);
	}
	public void start()
    {


 		if(wasReset == 1)
 		{
 			current = 0;
 		}
 		wasReset = 0;
		if(clockThread == null)
        {
			clockThread = new Thread(this);
            clockThread.start();
        }
    }
    public void zoom(int x)
    {
		zoom = x;
		repaint();
	}
	public void speed(int x)
	{
		sleepTime = 30 / x;
	}
    public void random()
    {
		for(int i = 0; i < WIDTH; i++)
		{
			int x = (int)(Math.random() * 2);
			cells[i][HEIGHT - 1] = x;
			if(x == 0)
				totalBear++;
			else
				totalBull++;
		}
	}
    public void reset()
    {
		stop();
		for (int i = 0; i < WIDTH; i++)
		{
			for (int j = 0; j < HEIGHT; j++)
			{
				cells[i][j] = 0;
			}
		}
		wasReset = 1;
		totalBear = 0;
		totalBull = 0;
		random();
		repaint();
	}
    public void stop()
    {
         clockThread=null;
    }
    public void run()
    {
		while (Thread.currentThread() == clockThread)
		{
			// shift
			for(int j = 0; j < HEIGHT - 1; j++)
			{
				for(int i = 0;  i < WIDTH; i++)
				{
					cells[i][j] = cells[i][j + 1];
				}
				if(j % 100 == 0)
				{
					   repaint();
					   try
					   {
							   Thread.currentThread().sleep(sleepTime);
					   }
					catch(InterruptedException e){}
				}
			}
			// now compute last row
				for(int i = 0;  i < WIDTH; i++)
				{
					int j = HEIGHT - 2;
					if(i == 0)
					{
						if(cells[WIDTH - 1][j] == 1 && cells[i][j] == 1 && cells[i + 1][j] == 1)
						{
							cells[i][j + 1] = Integer.parseInt(theBinary.substring(0,1 ));
						}
						else if(cells[WIDTH - 1][j] == 1 && cells[i][j] == 1 && cells[i + 1][j] == 0)
						{
							cells[i][j + 1] = Integer.parseInt(theBinary.substring(1,2 ));
						}
						else if(cells[WIDTH - 1][j] == 1 && cells[i][j] == 0 && cells[i + 1][j] == 1)
						{
							cells[i][j + 1] = Integer.parseInt(theBinary.substring(2, 3));
						}
						else if(cells[WIDTH - 1][j] == 1 && cells[i][j] == 0 && cells[i + 1][j] == 0)
						{
							cells[i][j + 1] = Integer.parseInt(theBinary.substring(3,4 ));;
						}
						else if(cells[WIDTH - 1][j] == 0 && cells[i][j] == 1 && cells[i + 1][j] == 1)
						{
							cells[i][j + 1] = Integer.parseInt(theBinary.substring(4, 5));
						}
						else if(cells[WIDTH - 1][j] == 0 && cells[i][j] == 1 && cells[i + 1][j] == 0)
						{
							cells[i][j + 1] = Integer.parseInt(theBinary.substring(5,6 ));
						}
						else if(cells[WIDTH - 1][j] == 0 && cells[i][j] == 0 && cells[i + 1][j] == 1)
						{
							cells[i][j + 1] = Integer.parseInt(theBinary.substring(6, 7));
						}
						else if(cells[WIDTH - 1][j] == 0 && cells[i][j] == 0 && cells[i + 1][j] == 0)
						{
							cells[i][j + 1] = Integer.parseInt(theBinary.substring(7,8 ));
						}
					}
					else if(i == WIDTH - 1)
					{
						if(cells[i - 1][j] == 1 && cells[i][j] == 1 && cells[0][j] == 1)
						{
							cells[i][j + 1] = Integer.parseInt(theBinary.substring(0, 1));
						}
						else if(cells[i - 1][j] == 1 && cells[i][j] == 1 && cells[0][j] == 0)
						{
							cells[i][j + 1] = Integer.parseInt(theBinary.substring(1, 2));
						}
						else if(cells[i - 1][j] == 1 && cells[i][j] == 0 && cells[0][j] == 1)
						{
							cells[i][j + 1] = Integer.parseInt(theBinary.substring(2,3 ));
						}
						else if(cells[i - 1][j] == 1 && cells[i][j] == 0 && cells[0][j] == 0)
						{
							cells[i][j + 1] = Integer.parseInt(theBinary.substring(3, 4));
						}
						else if(cells[i - 1][j] == 0 && cells[i][j] == 1 && cells[0][j] == 1)
						{
							cells[i][j + 1] = Integer.parseInt(theBinary.substring(4,5 ));
						}
						else if(cells[i - 1][j] == 0 && cells[i][j] == 1 && cells[0][j] == 0)
						{
							cells[i][j + 1] = Integer.parseInt(theBinary.substring(5,6 ));
						}
						else if(cells[i - 1][j] == 0 && cells[i][j] == 0 && cells[0][j] == 1)
						{
							cells[i][j + 1] = Integer.parseInt(theBinary.substring(6,7 ));
						}
						else if(cells[i - 1][j] == 0 && cells[i][j] == 0 && cells[0][j] == 0)
						{
							cells[i][j + 1] = Integer.parseInt(theBinary.substring(7,8 ));
						}
					}
					else
					{
						if(cells[i - 1][j] == 1 && cells[i][j] == 1 && cells[i + 1][j] == 1)
						{
							cells[i][j + 1] = Integer.parseInt(theBinary.substring(0,1 ));
						}
						else if(cells[i - 1][j] == 1 && cells[i][j] == 1 && cells[i + 1][j] == 0)
						{
							cells[i][j + 1] = Integer.parseInt(theBinary.substring(1,2 ));
						}
						else if(cells[i - 1][j] == 1 && cells[i][j] == 0 && cells[i + 1][j] == 1)
						{
							cells[i][j + 1] = Integer.parseInt(theBinary.substring(2,3 ));
						}
						else if(cells[i - 1][j] == 1 && cells[i][j] == 0 && cells[i + 1][j] == 0)
						{
							cells[i][j + 1] = Integer.parseInt(theBinary.substring(3,4 ));
						}
						else if(cells[i - 1][j] == 0 && cells[i][j] == 1 && cells[i + 1][j] == 1)
						{
							cells[i][j + 1] = Integer.parseInt(theBinary.substring(4,5 ));
						}
						else if(cells[i - 1][j] == 0 && cells[i][j] == 1 && cells[i + 1][j] == 0)
						{
							cells[i][j + 1] = Integer.parseInt(theBinary.substring(5,6 ));
						}
						else if(cells[i - 1][j] == 0 && cells[i][j] == 0 && cells[i + 1][j] == 1)
						{
							cells[i][j + 1] = Integer.parseInt(theBinary.substring(6,7 ));
						}
						else if(cells[i - 1][j] == 0 && cells[i][j] == 0 && cells[i + 1][j] == 0)
						{
							cells[i][j + 1] = Integer.parseInt(theBinary.substring(7,8 ));
						}
					}

					if(cells[i][j + 1] == 0)
						totalBear++;
					else
						totalBull++;
				}
			sp.setBB(totalBull, totalBear);
		}// end of while
    }// end of run ()
   	private Thread clockThread = null;
    private Font font = new Font("Monospaced", Font.BOLD, 48);
    private Font font2 = new Font("Arial", Font.PLAIN, 16);
    private Color white = Color.white;
    private Color black = Color.black;
	private int WIDTH = 300;
	private int HEIGHT = 400;
    private int[][] cells = new int[WIDTH][HEIGHT];

    private int zoom = 1;
    private int speed = 2;
    private JTextField rule;

    private int initial = 0;
    private int current = 0;
    private int wasReset = 0;
    private String theBinary = "";
    private int rule3  = 89;
    private int PWIDTH = 300;
    private int PHEIGHT = 400;
    private int sleepTime = 30;
    private int totalBear = 0; // Bear = 0
    private int totalBull = 0;
    private StockPanel2 sp;

    // image stuff
    private Dimension offDimension;
    private Image offImage;
    private Graphics offGraphics;
}

